package dev.shadowsoffire.apotheosis.ench.table;

package .tmp;

import com.google.gson.JsonObject;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingRecipe;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingStatRegistry;
import dev.shadowsoffire.apotheosis.ench.table.KeepNBTEnchantingRecipe;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.crafting.Recipe;
import net.minecraftforge.common.crafting.CraftingHelper;
import org.apache.commons.lang3.tuple.Pair;

public class Serializer extends EnchantingRecipe.Serializer {
  public KeepNBTEnchantingRecipe fromJson(ResourceLocation id, JsonObject obj) {
    ItemStack output = CraftingHelper.getItemStack(obj.get("result").getAsJsonObject(), true, true);
    Ingredient input = Ingredient.m_43917_(obj.get("input"));
    Pair<EnchantingStatRegistry.Stats, EnchantingStatRegistry.Stats> requirements = EnchantingRecipe.readStats(id, obj);
    return new KeepNBTEnchantingRecipe(id, output, input, requirements.getLeft(), requirements.getRight());
  }
}
